/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010-2012 by Meika Sugimoto
 *  Copyright (C) 2015 by Naoki Saito
 *              Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 */

/*
 *		VAC^tF[XhCo
 */

#include <kernel.h>
#include "target_syssvc.h"
#include "target_serial.h"
#include "serial.h"
#include "kernel_cfg.h"

/*
 *  obt@TCỸftHglƃobt@̒`
 */
#ifndef SERIAL_RCV_BUFSZ1
#define	SERIAL_RCV_BUFSZ1	64			/* |[g1̎Mobt@TCY */
#endif /* SERIAL_RCV_BUFSZ1 */

#ifndef SERIAL_SND_BUFSZ1
#define	SERIAL_SND_BUFSZ1	256			/* |[g1̑Mobt@TCY */
#endif /* SERIAL_SND_BUFSZ1 */

static char	rcv_buffer1[SERIAL_RCV_BUFSZ1];
static char	snd_buffer1[SERIAL_SND_BUFSZ1];

#if TNUM_PORT >= 2						/* |[g2Ɋւ` */

#ifndef SERIAL_RCV_BUFSZ2
#define	SERIAL_RCV_BUFSZ2	64			/* |[g2̎Mobt@TCY */
#endif /* SERIAL_RCV_BUFSZ2 */

#ifndef SERIAL_SND_BUFSZ2
#define	SERIAL_SND_BUFSZ2	64			/* |[g2̑Mobt@TCY */
#endif /* SERIAL_SND_BUFSZ2 */

static char	rcv_buffer2[SERIAL_RCV_BUFSZ2];
static char	snd_buffer2[SERIAL_SND_BUFSZ2];

#endif /* TNUM_PORT >= 2 */

#if TNUM_PORT >= 3						/* |[g3Ɋւ` */

#ifndef SERIAL_RCV_BUFSZ3
#define	SERIAL_RCV_BUFSZ3	64			/* |[g3̎Mobt@TCY */
#endif /* SERIAL_RCV_BUFSZ3 */

#ifndef SERIAL_SND_BUFSZ3
#define	SERIAL_SND_BUFSZ3	64			/* |[g3̑Mobt@TCY */
#endif /* SERIAL_SND_BUFSZ3 */

static char	rcv_buffer3[SERIAL_RCV_BUFSZ3];
static char	snd_buffer3[SERIAL_SND_BUFSZ3];

#endif /* TNUM_PORT >= 3 */

/*
 *  VA|[gubN
 */
typedef struct serial_port_initialization_block {
	uint_t	rcv_bufsz;		/* Mobt@TCY */
	char	*rcv_buffer;	/* Mobt@ */
	uint_t	snd_bufsz;		/* Mobt@TCY */
	char	*snd_buffer;	/* Mobt@ */
} SPINIB;

static const SPINIB spinib_table[TNUM_PORT] = {
	{ SERIAL_RCV_BUFSZ1, rcv_buffer1,
	  SERIAL_SND_BUFSZ1, snd_buffer1 },
#if TNUM_PORT >= 2
	{ SERIAL_RCV_BUFSZ2, rcv_buffer2,
	  SERIAL_SND_BUFSZ2, snd_buffer2 },
#endif /* TNUM_PORT >= 2 */
#if TNUM_PORT >= 3
	{ SERIAL_RCV_BUFSZ3, rcv_buffer3,
	  SERIAL_SND_BUFSZ3, snd_buffer3 },
#endif /* TNUM_PORT >= 3 */
};

/*
 *  VA|[gǗubN
 */
typedef struct serial_port_control_block {
	const SPINIB *p_spinib;		/* VA|[gubN */
	SIOPCB	*p_siopcb;			/* VAI/O|[gǗubN */
	bool_t	openflag;			/* I[vς݃tO */
	bool_t	errorflag;			/* G[tO */
	uint_t	ioctl;				/* 쐧̐ݒl */

	uint_t	rcv_read_ptr;		/* Mobt@Ǐo|C^ */
	uint_t	rcv_write_ptr;		/* Mobt@݃|C^ */
	uint_t	rcv_count;			/* Mobt@̕ */

	uint_t	snd_read_ptr;		/* Mobt@Ǐo|C^ */
	uint_t	snd_write_ptr;		/* Mobt@݃|C^ */
	uint_t	snd_count;			/* Mobt@̕ */
} SPCB;

static SPCB	spcb_table[TNUM_PORT];

/*
 *  VA|[gIDVA|[gǗubNo߂̃}N
 */
#define INDEX_PORT(portid)	((uint_t)((portid) - 1))
#define get_spcb(portid)	(&(spcb_table[INDEX_PORT(portid)]))

/*
 *  |C^̃CNg
 */
#define INC_PTR(ptr, bufsz)		{ if (++(ptr) == (bufsz)) { (ptr) = 0; }}

/*
 *  T[rXR[ďo}N
 *
 *  T[rXR[ďo܂ގexp]CԒlG[i̒lj̏
 *  ɂ́Cercercd_exp]lCerror_exitgotoD
 */
#define SVC(exp, ercd_exp) \
				{ if ((exp) < 0) { ercd = (ercd_exp); goto error_exit; }}

/*
 *  E_SYSG[̐
 */
static ER
gen_ercd_sys(SPCB *p_spcb)
{
	p_spcb->errorflag = true;
	return(E_SYS);
}


/*
 *  VAC^tF[XhCȍ[`
 */
void
serial_initialize(intptr_t exinf)
{
	uint_t	i;
	SPCB	*p_spcb;

	for (i = 0; i < TNUM_PORT; i++) {
		p_spcb = &(spcb_table[i]);
		p_spcb->p_spinib = &(spinib_table[i]);
		p_spcb->openflag = false;
	}
}

/*
 *  VAC^[tF[XhCȍI[`
 */

void
serial_terminate(intptr_t exinf)
{
	uint_t	i;
	SPCB	*p_spcb;
	
	/* obt@ɎcĂSĂ̕o͂ */
	for (i = 0; i < TNUM_PORT; i++) {
		p_spcb = &(spcb_table[i]);

		while(p_spcb->snd_count != 0U)
		{
			if(sio_snd_chr(p_spcb->p_siopcb,
					p_spcb->p_spinib->snd_buffer[p_spcb->snd_read_ptr]) == true)
			{
				INC_PTR(p_spcb->snd_read_ptr, p_spcb->p_spinib->snd_bufsz);
				p_spcb->snd_count--;
			}
		}
	}

}

/*
 *  VA|[g̃I[viT[rXR[j
 */
ER
serial_opn_por(ID portid)
{
	SPCB	*p_spcb;
	ER		ercd;

	if (sns_dpn()) {				/* ReLXg̃`FbN */
		return(E_CTX);
	}
	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);				/* |[gԍ̃`FbN */
	}
	p_spcb = get_spcb(portid);

	SVC(dis_dsp(), gen_ercd_sys(p_spcb));
	if (p_spcb->openflag) {			/* I[vς݂̃`FbN */
		ercd = E_OBJ;
	}
	else {
		/*
		 *  ϐ̏
		 */
		p_spcb->ioctl = (IOCTL_ECHO | IOCTL_CRLF);

		p_spcb->rcv_read_ptr = p_spcb->rcv_write_ptr = 0U;
		p_spcb->rcv_count = 0U;

		p_spcb->snd_read_ptr = p_spcb->snd_write_ptr = 0U;
		p_spcb->snd_count = 0U;

		/*
		 *  ȍ~C݂֎~D
		 */
		if (loc_cpu() < 0) {
			ercd = E_SYS;
			goto error_exit_enadsp;
		}

		/*
		 *  n[hEFAˑ̃I[v
		 */
		p_spcb->p_siopcb = sio_opn_por(portid, (intptr_t) p_spcb);

		/*
		 *  MʒmR[obND
		 */
		sio_ena_cbr(p_spcb->p_siopcb, SIO_RDY_RCV);
		p_spcb->openflag = true;
		p_spcb->errorflag = false;

		if (unl_cpu() < 0) {
			p_spcb->errorflag = true;
			ercd = E_SYS;
			goto error_exit_enadsp;
		}
		ercd = E_OK;
	}

  error_exit_enadsp:
	SVC(ena_dsp(), gen_ercd_sys(p_spcb));

  error_exit:
	return(ercd);
}

/*
 *  VA|[g̃N[YiT[rXR[j
 */
ER
serial_cls_por(ID portid)
{
	SPCB	*p_spcb;
	ER		ercd;
	bool_t	eflag = false;

	if (sns_dpn()) {				/* ReLXg̃`FbN */
		return(E_CTX);
	}
	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);				/* |[gԍ̃`FbN */
	}
	p_spcb = get_spcb(portid);

	SVC(dis_dsp(), gen_ercd_sys(p_spcb));
	if (!(p_spcb->openflag)) {		/* I[vς݂̃`FbN */
		ercd = E_OBJ;
	}
	else {
		/*
		 *  n[hEFAˑ̃N[Y
		 */
		if (loc_cpu() < 0) {
			eflag = true;
		}
		sio_cls_por(p_spcb->p_siopcb);
		p_spcb->openflag = false;
		if (unl_cpu() < 0) {
			eflag = true;
		}
		
		/*
		 *  G[R[h̐ݒ
		 */
		if (eflag) {
			ercd = gen_ercd_sys(p_spcb);
		}
		else {
			ercd = E_OK;
		}
	}
	SVC(ena_dsp(), gen_ercd_sys(p_spcb));

  error_exit:
	return(ercd);
}

/*
 *  VA|[gւ̕M
 *
 *  p_spcbŎw肳VAI/O|[gɑ΂āCc𑗐MD
 *  𑗐MWX^ɂꂽꍇɂtrueԂDłȂꍇɂ́CM
 *  WX^󂢂ƂʒmR[obN֐CfalseԂD
 *  ̊֐́CCPUbNԂŌĂяoD
 */
Inline bool_t
serial_snd_chr(SPCB *p_spcb, char c)
{
	if (sio_snd_chr(p_spcb->p_siopcb, c)) {
		return(true);
	}
	else {
		sio_ena_cbr(p_spcb->p_siopcb, SIO_RDY_SND);
		return(false);
	}
}

/*
 *  VA|[gւ1M
 *  w肳ꂽ̑M݂.
 *  foCXւ̑Mꍇ܂̓obt@ɋ󂫂i[łꍇ false, 
 *  obt@tŊi[łȂꍇ true ԂD
 *  ȊÕG[ꍇ ER ^̃G[R[hԂD
 */
static ER_BOOL
serial_wri_chr(SPCB *p_spcb, char c)
{
	bool_t	buffer_full;
	ER		ercd, rercd;

	/*
	 *  LF̑OCR𑗐MD
	 *  C1ȉ̋󂫂Ȃꍇ̓obt@tƂ݂ȂCMȂD
	 */
	if (c == '\n' && (p_spcb->ioctl & IOCTL_CRLF) != 0U) {
		if(p_spcb->snd_count + 1U < p_spcb->p_spinib->snd_bufsz) {
			SVC(rercd = serial_wri_chr(p_spcb, '\r'), rercd);
		}
		else {
			return (ER_BOOL) true;
		}
	}

	SVC(loc_cpu(), gen_ercd_sys(p_spcb));
	if ((p_spcb->snd_count == 0U) && serial_snd_chr(p_spcb, c)) {
		/*
		 *  VAI/OfoCX̑MWX^ɕ邱Ƃɐ
		 *  ꍇD
		 */
		buffer_full = false;
	}
	else {
		/*
		 *  󂫂΁CMobt@ɕD
		 *  󂫂ȂꍇCMȂD
		 */
		if(p_spcb->snd_count < p_spcb->p_spinib->snd_bufsz) {
			p_spcb->p_spinib->snd_buffer[p_spcb->snd_write_ptr] = c;
			INC_PTR(p_spcb->snd_write_ptr, p_spcb->p_spinib->snd_bufsz);
			p_spcb->snd_count++;
			buffer_full = false;
		}
		else {
			buffer_full = true;
		}
	}

	SVC(unl_cpu(), gen_ercd_sys(p_spcb));
	ercd = (ER_BOOL) buffer_full;

  error_exit:
	return(ercd);
}

bool_t
serial_rcvbuf_empty(SPCB *p_spcb)
{
	return (p_spcb->rcv_count == 0u);
}

/*
 *  VA|[gւ̕񑗐MiT[rXR[j
 */
ER_UINT
serial_wri_dat(ID portid, const char *buf, uint_t len)
{
	SPCB	*p_spcb;
	bool_t	buffer_full;
	uint_t	wricnt = 0U;
	ER		ercd, rercd;

	if (sns_dpn()) {				/* ReLXg̃`FbN */
		return(E_CTX);
	}
	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);				/* |[gԍ̃`FbN */
	}

	p_spcb = get_spcb(portid);
	if (!(p_spcb->openflag)) {		/* I[vς݂̃`FbN */
		return(E_OBJ);
	}
	if (p_spcb->errorflag) {		/* G[Ԃ̃`FbN */
		return(E_SYS);
	}
	
	/*
	 *  len ܂1M݂D
	 *  rŃobt@tɂȂ璆fD
	 */
	SVC((rercd = dis_dsp()) , rercd);
	for(wricnt = 0U; wricnt < len; wricnt++) {
		SVC(rercd = serial_wri_chr(p_spcb, *buf++), rercd);
		buffer_full = (bool_t)rercd;
		if(buffer_full) {
			break;
		}
	}
	SVC((rercd = ena_dsp()) , rercd);
	
	ercd = E_OK;
  error_exit:
	return(wricnt > 0U ? (ER_UINT) wricnt : ercd);
}

/*
 *  VA|[g1M
 *  ̎M݂.
 *  obt@Ƀf[^݂C擾łꍇ false, 
 *  obt@Ŏ擾łȂꍇ true ԂD
 *  ȊÕG[ꍇ ER ^̃G[R[hԂD
 */
static ER_BOOL
serial_rea_chr(SPCB *p_spcb, char *p_c)
{
	bool_t	buffer_empty;
	ER		ercd;

	SVC(loc_cpu(), gen_ercd_sys(p_spcb));

	/*
	 *  f[^݂΁CMobt@當oD
	 *  ȂΎoȂD
	 */
	if(p_spcb->rcv_count > 0U) {
		*p_c = p_spcb->p_spinib->rcv_buffer[p_spcb->rcv_read_ptr];
		INC_PTR(p_spcb->rcv_read_ptr, p_spcb->p_spinib->rcv_bufsz);
		p_spcb->rcv_count--;
		buffer_empty = false;
	}
	else {
		buffer_empty = true;
	}
	
	SVC(unl_cpu(), gen_ercd_sys(p_spcb));
	ercd = (ER_BOOL) buffer_empty;

  error_exit:
	return(ercd);
}

/*
 *  VA|[g̕MiT[rXR[j
 */
ER_UINT
serial_rea_dat(ID portid, char *buf, uint_t len)
{
	SPCB	*p_spcb;
	bool_t	buffer_empty;
	uint_t	reacnt = 0U;
	char	c = '\0';		/* RpČx}~邽߂ɏ */
	ER		ercd, rercd;

	if (sns_dpn()) {				/* ReLXg̃`FbN */
		return(E_CTX);
	}
	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);				/* |[gԍ̃`FbN */
	}

	p_spcb = get_spcb(portid);
	if (!(p_spcb->openflag)) {		/* I[vς݂̃`FbN */
		return(E_OBJ);
	}
	if (p_spcb->errorflag) {		/* G[Ԃ̃`FbN */
		return(E_SYS);
	}
	
	/*
	 *  len ܂ŎM݂D
	 *  obt@œǂݏoȂꍇ͒f
	 */
	SVC((rercd = dis_dsp()) , rercd);
	for(reacnt = 0U; reacnt < len; reacnt++) {
		SVC(rercd = serial_rea_chr(p_spcb, &c), rercd);
		buffer_empty = (bool_t)rercd;

		if(buffer_empty) {
			break;
		}
		else {
			/*
			 *  GR[obND
			 */
			if ((p_spcb->ioctl & IOCTL_ECHO) != 0U) {
				SVC(rercd = serial_wri_chr(p_spcb, c), rercd);
			}
			*buf++ = c;
		}
	}
	SVC((rercd = ena_dsp()) , rercd);
	
	ercd = E_OK;
  error_exit:
	return(reacnt > 0U ? (ER_UINT) reacnt : ercd);
}

/*
 *  VA|[g̐iT[rXR[j
 */
ER
serial_ctl_por(ID portid, uint_t ioctl)
{
	SPCB	*p_spcb;

	if (sns_dpn()) {				/* ReLXg̃`FbN */
		return(E_CTX);
	}
	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);				/* |[gԍ̃`FbN */
	}

	p_spcb = get_spcb(portid);
	if (!(p_spcb->openflag)) {		/* I[vς݂̃`FbN */
		return(E_OBJ);
	}
	if (p_spcb->errorflag) {		/* G[Ԃ̃`FbN */
		return(E_SYS);
	}

	p_spcb->ioctl = ioctl;
	return(E_OK);
}

/*
 *  VA|[g̑M\R[obN
 */
void
sio_irdy_snd(intptr_t exinf)
{
	SPCB	*p_spcb;

	p_spcb = (SPCB *) exinf;

	if (p_spcb->snd_count > 0U) {
		/*
		 *  Mobt@當ođMD
		 */
		(void) sio_snd_chr(p_spcb->p_siopcb,
					p_spcb->p_spinib->snd_buffer[p_spcb->snd_read_ptr]);
		INC_PTR(p_spcb->snd_read_ptr, p_spcb->p_spinib->snd_bufsz);
		p_spcb->snd_count--;
	}
	else {
		/*
		 *  MׂȂꍇ́CM\R[obN֎~D
		 */
		sio_dis_cbr(p_spcb->p_siopcb, SIO_RDY_SND);
	}
}

/*
 *  VA|[g̎MʒmR[obN
 */
void
sio_irdy_rcv(intptr_t exinf)
{
	SPCB	*p_spcb;
	char	c;
	
	p_spcb = (SPCB *) exinf;
	c = (char) sio_rcv_chr(p_spcb->p_siopcb);
	
	if (p_spcb->rcv_count != p_spcb->p_spinib->rcv_bufsz) {
		/*
		 *  MMobt@ɓD
		 *  obt@t̏ꍇCM̂ĂD
		 */
		p_spcb->p_spinib->rcv_buffer[p_spcb->rcv_write_ptr] = c;
		INC_PTR(p_spcb->rcv_write_ptr, p_spcb->p_spinib->rcv_bufsz);
		p_spcb->rcv_count++;
	}
}

/*
 *  VAC^tF[XhCo̖M̎o
 */
bool_t
serial_get_chr(ID portid, char *p_c)
{
	SPCB	*p_spcb;

	if (1 <= portid && portid <= TNUM_PORT) {	/* |[gԍ̃`FbN */
		p_spcb = get_spcb(portid);
		if (p_spcb->openflag) {					/* I[vς݂̃`FbN */
			if (p_spcb->snd_count > 0U) {
				*p_c = p_spcb->p_spinib->snd_buffer[p_spcb->snd_read_ptr];
				INC_PTR(p_spcb->snd_read_ptr, p_spcb->p_spinib->snd_bufsz);
				p_spcb->snd_count--;
				return(true);
			}
		}
	}
	return(false);
}
